﻿ param(
  [switch]$Verbose,
  [switch]$Debug,
  [string]$Test
)

if ($Verbose) { $VerbosePreference = "Continue" }
if ($Debug) { $DebugPreference = "Continue" }

Write-Debug "Command line is ___$($MyInvocation.Line)___"
Write-Verbose "Entering script body"

If (-Not ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator")) {
  Write-Verbose "Script is not run with administrative user"

  If ((Get-WmiObject Win32_OperatingSystem | select BuildNumber).BuildNumber -ge 6000) {
    Write-Verbose "Found UAC-enabled system. Elevating ..."

    $CommandLine = $MyInvocation.Line.Replace($MyInvocation.InvocationName, $MyInvocation.MyCommand.Definition)
    Write-Verbose "  $CommandLine"
 
    Start-Process -FilePath PowerShell.exe -Verb Runas -ArgumentList "$CommandLine"

  } else {
    Write-Verbose "System does not support UAC"
    Write-Warning "This script requires administrative privileges. Elevation not possible. Please re-run with administrative account."
  }
  Break
}

Write-Verbose "Script is now running elevated"
$Test
 
 Echo "TouchFix v1.0"
 Echo "Based on regkeys from `nhttp://forum.xda-developers.com/showthread.php?t=2091867"
 Echo "Self Elevation Header from `nhttp://www.sepago.de/e/nicholas/2011/05/20/automatically-elevating-a-powershell-script" 
 Echo "================"
 Echo ""
 Echo "This script should help to improve the responsiveness and stability of your touchscreen."
 Echo "Smaller values MAY affect battery life on portable devices, but each device is different..."
 $newval = read-host -Prompt "What value should we set the keys to? (Default is 8, Optimal is 2) "
 
 if (Test-Path HKLM:\Software\Microsoft\TouchPrediction)
 {
 Set-ItemProperty -Path HKLM:\Software\Microsoft\TouchPrediction -Name Latency -Value $newval
 Set-ItemProperty -Path HKLM:\Software\Microsoft\TouchPrediction -Name SampleTime -Value $newval
 Echo "Update complete. `nLatency and SampleTime values set to $newval"
 }
 $a = read-host -Prompt "Press any key to exit..."